/***************************************************************************
                          app.h  -  description
                             -------------------
    begin                : Wed Jul  7 07:29:49 IST 2004
    copyright            : (C) 2004 by Hans Mathew
    email                : hansprog@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/*** gviewzip-apph */

#ifndef GVIEWZIP_APP_H
#define GVIEWZIP_APP_H

#include <gnome.h>

#define READBYTES(_x, _len)	{size_t _count;\
				_count = fread(_x, 1, _len, zipfile);\
   			if(_count != (_len))\
   			{\
					nret = 0;\
					break;\
   			}\
			}

#define GETYEARFROMDOSDATE(lastmodfiletime) (gint)(((guint)lastmodfiletime >> 9) & 0x7F) + 1980;
#define GETMONTHFROMDOSDATE(lastmodfiletime) (gint)((guint)lastmodfiletime >> 5) & 0xF;
#define GETDAYFROMDOSDATE(lastmodfiletime) (gint)((guint)lastmodfiletime) & 0x1F;
#define GETHOURFROMDOSTIME(lastmodfiletime) (gint)((guint)lastmodfiletime >> 11) & 0x1F;
#define GETMINUTEFROMDOSTIME(lastmodfiletime) (gint)((guint)lastmodfiletime >> 5) & 0x3F;
#define GETSECONDFROMDOSTIME(lastmodfiletime) (gint)((guint)lastmodfiletime << 1) & 0x3E;

#define CLIST_MAX_COLS 12
#define CLIST_NUM_COLS 6

#define PATHSIZE 1024
#define BUFSIZE 1024
#define DATESTRSIZE 20

#define EXTRAHEADERSIZE 4
#define EXTRADATASIZEOFF 2

#define ENCRYPTEDFILE 1
#define VIEWEDFILE 2

struct strlocalfileheader
{
	gint fileheadersignature;
  gushort versionneededtoextract;
  gushort generalpurposebitflag;
  gushort compressionmethod;
  gushort lastmodfiletime;
  gushort lastmodfiledate;
  guint crc32;
  guint compressedsize;
  guint uncompressedsize;
  gushort filenamelength;
  gushort extrafieldlength;
};

struct strrowdata
{
	/* Date used to sort */
	gchar datestring[DATESTRSIZE];
	/* 1 if encrypted 2 if viewed */
	gint flag;
};

struct strmtdata
{
	GtkWidget *app;
	GtkWidget *clist;
};

enum enumcolumn{MODDATE, CRC32, SIZEZIP, SIZEUNZIP, FILENAME, PATH, COLUMNNONE};
enum enumvaluetype{FILEDATE, STRING, NUMBER, VALUENONE};
enum enumflag{YES, NO};
enum enumdateformat{GENERIC, AMERICAN, BRITISH, COMPARE};

gint clear(GtkWidget* clist);

GtkWidget* gviewzip_app_new(const gchar* zipfile/*const gchar* message*/,
                         const gchar* geometry/*,
                         GSList* greet*/);

void       gviewzip_app_close(GtkWidget* app);

enum enumcolumn findcolumn(gint findindex);
gint openzipfile(const gchar *filename, GtkWidget *app, GtkWidget *clist);
gint is_executable(gchar *filename);

#endif

/* gviewzip-apph ***/
